var payUtils = require("../../utils/payUtils.js");

Page({
  data: {
    goodsNum:0,
    payPrice:0.00,
    totalPrice:0.00,
    couponPrice:0.00,
    qrPayShow:false,
    list:[],
    orderNo:"",
    isCashierClosed:false,
    isPaying: false,
  },
  onLoad(options) {
    var totalQuantity = options.totalQuantity
    var totalPrice = options.totalPrice
    var totalDisc = options.totalDisc

    if (totalQuantity != null) {
      this.setData({
        goodsNum: totalQuantity,
      })
    }

    //暂时没有优惠
    if (totalPrice != null) {
      this.setData({
        payPrice: totalPrice,
        totalPrice: totalPrice,
      })
    }

  },


  facePay() {

  },

  qrPay() {
    //todo 这里增加唤起弹窗的逻辑
    this.setData({
      qrPayShow: true
    });
  },

  /**
   * 保存最近支付成功的相关信息，每次支付成功都需刷新
   * @param paySuccessGoodsList 支付成功的商品列表信息
   * @param paySuccessResponse 支付成功响应,即云中台返回响应中的data信息
   */
  saveData(paySuccessGoodsList, paySuccessResponse) {
    my.setStorageSync({
      key: 'paySuccessGoodsList',
      data: paySuccessGoodsList
    });
    my.setStorageSync({
      key: 'paySuccessResponse',
      data: paySuccessResponse
    });
  },

  /**
 * @todo 支付结果的获取
 * @todo 跳转数据的保存
 */
  startPay(){
    //开始loading
    my.showLoading({});

    //获取order
    payUtils.getOrder(/*this.data.payPrice*/1,this.data.list, function(res){
      if(res != null){

        console.log("callback调用,res="+JSON.stringify(res));
        if(res.resultCode ==1){
          this.setData({
            orderNo:res.data
          });
           this.payWithOpenCashier(res.data);
        }
      }
    }.bind(this));
  },

  //调用收款接口
  doPay(orderNo, payCode) {
    console.log("doPay调用"+orderNo);
    this.setData({isPaying:true});
    //使用barCode来当面付
    payUtils.startPay(orderNo, payCode, 1, this.data.list, function(res){
      my.hideLoading();
      console.log("支付回调  ===>" + JSON.stringify(res));
      this.setData({isPaying:false});
      if(res == null){
        return;
      }
      if(res.resultCode == 1){
        //成功
        console.log("支付回调成功，跳转 " );
        // if(data.isCashierClosed == true){
          my.ix.offCashierEventReceive();
          my.redirectTo({
            url: '/pages/paysuccess/paysuccess?orderPrice=' + this.data.totalPrice + "&couponPrice=" + this.data.couponPrice + "&payPrice=" + this.data.payPrice+"&totalCount="+this.data.totalCount,
          });
        // }
      }else{
        console.log("支付回调失败，toast提示  ");
        my.ix.offCashierEventReceive();
        my.showToast({
            type: 'fail',
            content: res.data,
            duration: 2000
        });
      }
    }.bind(this));
  },

  /**
   * 打开收银台，进行扫码收款
   */
  payWithOpenCashier(orderNo){
    
    try{
      console.info("收银台版本" + my.ix.getVersionSync({
          packageName: 'zoloz.phone.android.alipay.com.dragonfly'
      }).versionName);

      //开启收银台监听
      my.ix.startApp({
        appName: "cashier",
        bizNo: this.data.orderNo,
        totalAmount: this.data.payPrice,
        success: (res) => {
          console.log("收银台启动回调 success==>" + JSON.stringify(res));
          if (res.codeType == "F") {
            this.doPay(orderNo, res.barCode);
          } else {
            this.data.isCashierClosed = true;
            this.doPay(orderNo, res.barCode);
          }
        },fail:(res) => {
          my.showToast({
            type: 'exception',
            content: api.decodeErrorMessage(res.error),
            duration: 2000
          });
        }
      });
      //收银台回调
      my.ix.onCashierEventReceive((res) => {
        console.log("onCashierEventReceive==>" + JSON.stringify(res));

        if (res.bizType == 'RESULT_CLOSED' || res.status == "RESULT_CLOSE") {
          console.log("收银台关闭");
          this.data.isCashierClosed = true;
          //关闭监听
          my.ix.offCashierEventReceive();
          if (this.data.isPaying == true) {
            //如果正在支付中，则等待支付结果返回
          } else {
            //跳转支付结果页面，说明支付已完成,无论取消支付还是支付成功等都跳转支付结果页
            
            // if (this.data.actualPayPriceYuan != null) {
            //   my.redirectTo({
            //     //payPrice和couponPrice需要考虑支付宝优惠
            //     url: '/pages/paysuccess/paysuccess?orderPrice=' + this.data.totalPrice + "&couponPrice=" + this.data.couponPrice + "&payPrice=" + this.data.payPrice+"&totalCount="+this.data.totalCount,
            //   });
            // } else {
            //   //说明用户取消了支付
            //   my.redirectTo({
            //     url: '/pages/paysuccess/paysuccess?payFailedMsg=' + "用户取消" + "&payPriceYuan=" + this.data.payPriceYuan,
            //   });
            // }
          }
        } else if (res.bizType == 'RESULT_BTN_FUNCTION')
          console.log("收银台自定义按钮按下");
        else if (res.bizType == 'RESULT_MEMBER')
          console.log("支付结果页会员开卡");
        else
          console.log('RESULT: ' + res.bizType);
      });
    } catch(err) {
      console.log("收银台启动回调 异常==>" + JSON.stringify(err));
    }
    
  },
});
