Page({
  data: {
    orderPriceYuan: "--.--",
    orderPriceFen: 0,
    couponPriceYuan: "--.--",
    couponPriceFen: 0,
    payPriceYuan: "--.--",
    payPriceFen: 0,
    totalCount: 0,
    printerStatus: "小票打印中",
    couponPriceYuan: "--.--",
    couponHint: "xxxxxx",
    couponName: "xxxxxxxx",
    couponDateDuration: "xxxx.xx.xx-xxxx.xx.xx",
    isShowCoupon: false,
    isShowPrinting: true,
    goodsList: [],
    payChannel: "未知",
    paySuccessResponse: null
  },
  onLoad(query) {
    console.info(`Page onLoad with query: ${JSON.stringify(query)}`);
    //从本地获取相关数据
    this.data.goodsList.push(my.getStorageSync({ key: 'paySuccessGoodsList' }).data);
    this.data.paySuccessResponse = my.getStorageSync({ key: 'paySuccessResponse' }).data;
    //单位转换&赋值
    this.data.orderPriceFen = this.data.paySuccessResponse.tradeAmount;
    this.data.couponPriceFen = this.data.paySuccessResponse.mdiscount + this.data.paySuccessResponse.discount;
    this.data.payPriceFen = this.data.paySuccessResponse.tradeAmount - (this.data.paySuccessResponse.mdiscount + this.data.paySuccessResponse.discount);
    this.data.totalCount = query.totalCount;

    var miyapay = require("../../utils/miyapay4.js");
    this.data.orderPriceYuan = miyapay.fen2Yuan(this.data.orderPriceFen);
    this.data.couponPriceYuan = miyapay.fen2Yuan(this.data.couponPriceFen);
    this.data.payPriceYuan = miyapay.fen2Yuan(this.data.payPriceFen);

    //支付渠道 
    if (this.data.paySuccessResponse.channel == 1) {
      this.data.payChannel = "微信";
    } else if (this.data.paySuccessResponse.channel == 3) {
      this.data.payChannel = "支付宝";
    }
  },

  print() {
    //发起打印
    var printer = require("../../utils/printer.js");
    var printCallbackTemp = this.printCallback.bind(this);
    var cmds = [
      printer.setAlign(printer.ALIGN_CENTER),
      printer.printText(getApp().globalData.localAccountInfo.storeName),
      printer.printDivide("-"),
      printer.setAlign(printer.ALIGN_LEFT),
      printer.printText("门店号：" + this.paySuccessResponse.storeId),
      printer.printText("收银员账号：" + this.paySuccessResponse.operatorId),
      printer.printText("订单号：" + this.paySuccessResponse.tradeNo),
      printer.printNowDate(),
      printer.printDivide("-"),
      printer.printText("活动商品"),
      printer.printText("商品名称    " + "    编码    " + "    数量"),
    ];
    for (var i = 0; i < this.data.goodsList.length; i++) {
      //循环取出商品数据
      cmds.push(printer.setAlign(printer.ALIGN_LEFT));
      cmds.push(printer.printText(goodsList[i].goodsName));
      cmds.push(printer.printText(goodsList[i].barcode));
      cmds.push(printer.setAlign(printer.ALIGN_RIGHT));
      cmds.push(printer.printText(goodsList[i].goodsCount));
    }
    cmds.push(printer.setAlign(printer.ALIGN_LEFT));
    cmds.push(printer.printDivide("-"));
    cmds.push(printer.printText("应收金额:" + this.data.orderPriceYuan));
    cmds.push(printer.printText("支付方式实付:" + this.data.payPriceYuan));
    for (var i = 0; i < 4; i++) {
      cmds.push(printer.feedPaper());
    }
    printer.print({
      isCheckStatus: getApp().globalData.containerVersionCode > 20,
      cmds: cmds,
      callback: printCallbackTemp
    });
  },


  printCallback(res) {
    //通知后屏打印结果
    my.ix.sendBuddyMessage({
      target: "****************",
      // 填入目标小程序的 AppID
      data: res,
      success: (res) => {
        console.info(`sendBuddyMessage success: ${JSON.stringify(res)}`);
      },
      fail: (res) => {
        console.info(`sendBuddyMessage failed: ${JSON.stringify(res)}`);
      }
    });
    this.setData({
      isShowPrinting: false
    });
    if (res.code == -1) {
      //打印失败
      this.setData({
        printerStatus: "打印失败"
      });
    } else {
      //打印成功
      this.setData({
        printerStatus: "打印成功"
      });
    }
  },

  onShow() {
    //开启后屏监听
    my.ix.onBuddyMessage({
      success: (res) => {
        console.info(`onBuddyMessage success: ${JSON.stringify(res)}`);
        if ("") {
          //重新打印 

        } else {
          //未知指令
        }
      }
    });
  },

  onHide() {
    //关闭后屏监听
    my.ix.offBuddyMessage();
  }
});
