var api = require("../../utils/api.js");
import { Page } from '../../utils/scan';
import {API_SCAN} from '../../const/apiurl'
import {API_USE_COUPON} from '../../const/apiurl'


Page({
  data: {
    goods: [],
    //单位是元
    totalPrice: 0.00,
    totalQuantity: 0,
    totalDisc:0.00,
    memberPhone:'',
    memberPoint:0
  },

  onLoad: function (options) {
    var barcode = options.barcode
    if(barcode != null){
      console.log("首页传递过来的商品条码是 " + barcode);
      this.getGoodInfoByBarcode(barcode)
    }
  },

  //外接扫码枪事件
  onKeyPress(r) {
    console.log("scan onKeyPress==>" + r);
    this.getGoodInfoByBarcode(r);
  },

  //获取商品信息
  getGoodInfoByBarcode(barcode) {
    ////根据条形码查询商品接口
    my.showLoading({});
    var scanGoodRequest = api.createCommonRequest();
    scanGoodRequest.goodsId = barcode;
    //管理员需要额外传一个storeid 但是目前这个设备是没有
    // let storeId = getApp().globalData.localAccountInfo.storeId
    // let actType = getApp().globalData.localAccountInfo.actType
    //  if (storeId != null && actType == 1) {
    //    scanGoodRequest = storeId
    //  }
    console.log("扫商品的请求 ==>" + JSON.stringify(scanGoodRequest));
    my.request({
      url: getApp().globalData.BASE_URL + API_SCAN,
      method: 'POST',
      dataType: 'json',
      timeout: 30000,
      data: scanGoodRequest,
      success: (res) => {
        my.hideLoading();
        console.log("扫描商品成功 ==>" + JSON.stringify(res));
        if (res.data.success != true) {
          my.showToast({
            type: 'fail',
            content: res.data.message,
            duration: 2000
          });
        } else {
          var arr = Object.keys(res.data.data);
          if (arr.length == 0) {
            my.showToast({
              type: 'fail',
              content: "该商品没有对应的活动",
              duration: 2000
            });
          } else {
            //识别商品成功
            this.parseGoodInfo(res.data.data);
            console.log("识别商品信息成功");
          }
        }
      },
      fail: (res) => {
        my.hideLoading();
        console.log("扫商品的请求 ==>" + JSON.stringify(res));
        my.showToast({
          type: 'exception',
          content: api.decodeErrorMessage(res.error),
          duration: 2000
        });
      }
    });
  },


  //转化商品信息
  parseGoodInfo(goodinfo) {
 
    //价格 分转元
    goodinfo.quantity = 1;
    goodinfo.price = goodinfo.price/100 
    goodinfo.salePrice = goodinfo.salePrice/100 
    goodinfo.discnt = goodinfo.discnt/100 

    //总数量
    let totalQuantityTemp = 0
    //总价格
    let totalPriceTemp = 0.00

    //数量+1 
    let isHasSame = false;
    let lastgoods = this.data.goods;
    let goodstemp = []
    let goodtemp
    lastgoods.forEach(function (item, index, array) {
      if(item.barcode == goodinfo.barcode){
        let quantitytemp = item.quantity
        item.quantity = quantitytemp+1
        isHasSame = true
        goodtemp = item
      }else{
        totalQuantityTemp = totalQuantityTemp + item.quantity
        totalPriceTemp = totalPriceTemp + item.price*item.quantity
        goodstemp.push(item)
      }
 
    }) 
    if(isHasSame){
        totalQuantityTemp = totalQuantityTemp + goodtemp.quantity
        totalPriceTemp = totalPriceTemp + goodtemp.price*goodtemp.quantity

        let nowgoods = []
        nowgoods.push(goodtemp);
        var newgoods = nowgoods.concat(goodstemp)
        this.setData({ goods: newgoods })
    }else{
        totalQuantityTemp = totalQuantityTemp + 1
        totalPriceTemp = totalPriceTemp + goodinfo.price
        let nowgoods = []
        nowgoods.push(goodinfo);
        var newgoods = nowgoods.concat(lastgoods)
        this.setData({ goods: newgoods })
    }
    
     //汇总
     this.setData({ totalQuantity: totalQuantityTemp,
     totalPrice: totalPriceTemp,
     })

  },

  //跳转结算页面 
  goBalance() {
    my.navigateTo({
            url: "/pages/balance/balance?totalPrice=0.01" +"&totalQuantity="+this.data.totalQuantity+"&totalDisc="+this.data.totalDisc,

      // url: "/pages/balance/balance?totalPrice=" + this.data.totalPrice+"&totalQuantity="+this.data.totalQuantity+"&totalDisc="+this.data.totalDisc,
    });
  },


  //核销券
  verifyCoupon(code) {
    my.showLoading({});
    var couponRequest = api.createCommonRequest();
    couponRequest.couponCode = barcode;
    console.log("核销券的请求 ==>" + JSON.stringify(couponRequest));
    my.request({
      url: getApp().globalData.BASE_URL + API_USE_COUPON,
      method: 'POST',
      dataType: 'json',
      timeout: 30000,
      data: couponRequest,
      success: (res) => {
        my.hideLoading();
        console.log("核销券成功 ==>" + JSON.stringify(res));
        if (res.data.success != true) {
          my.showToast({
            type: 'fail',
            content: res.data.message,
            duration: 2000
          });
        } else {
          console.log("核销券成功");
        }
      },
      fail: (res) => {
        my.hideLoading();
        console.log("核销券失败 ==>" + JSON.stringify(res));
        my.showToast({
          type: 'exception',
          content: api.decodeErrorMessage(res.error),
          duration: 2000
        });
      }
    });
  },







});